var W:int = 54;
var H:int = 32;//12;
//stage.quality = StageQuality.MEDIUM;

//this is literally only named .js so it'll get syntax colored in notepad++ and visual studio
//it should be a .as file


var BASIC_TILE_BEGIN:int = 1;
var TOGGLE_TILE_BEGIN:int = 50;
var TAG_TILE_BEGIN:int = 100;
var OVERLAY_TILE_BEGIN:int = 225;
var ENEMIES_BEGIN:int = 250;
var BACKGROUND_BEGIN:int = 400;
var BACKGROUND2_BEGIN:int = 425;

var BASIC_COUNT:int = 41;
var TOGGLE_COUNT:int = 0;
var TAG_COUNT:int = 106;
var OVERLAY_COUNT:int = 10;
var ENEMY_COUNT:int = 122;
var BACKGROUND_COUNT:int = 58;

var BASIC_TILE_BEGIN_SAVEFILE:int = 0;
var TOGGLE_TILE_BEGIN_SAVEFILE:int = 10000;
var TAG_TILE_BEGIN_SAVEFILE:int = 20000;
var OVERLAY_TILE_BEGIN_SAVEFILE:int = 30000;
var ENEMIES_BEGIN_SAVEFILE:int = 40000;
var BACKGROUND_BEGIN_SAVEFILE:int = 50000;


function REFLECT(val, a, b){
    if(val == a) return b;
    if(val == b) return a;
    return val;
}
function REFLECT_BG(val, a, b){
    return REFLECT(val, BACKGROUND_BEGIN+a-1, BACKGROUND_BEGIN+b-1);
}

function REFLECT_TILE(val){
    val = REFLECT(val, 4+1, 2+1);
    
    val = REFLECT(val, 15+1, 13+1);
    
    val = REFLECT(val, ENEMIES_BEGIN+1, ENEMIES_BEGIN+0);
    val = REFLECT(val, ENEMIES_BEGIN+5, ENEMIES_BEGIN+2);
    val = REFLECT(val, ENEMIES_BEGIN+4, ENEMIES_BEGIN+3);
    val = REFLECT(val, ENEMIES_BEGIN+13, ENEMIES_BEGIN+12);
    val = REFLECT(val, ENEMIES_BEGIN+27, ENEMIES_BEGIN+29);
    val = REFLECT(val, ENEMIES_BEGIN+46, ENEMIES_BEGIN+47);
    
    val = REFLECT(val, TOGGLE_TILE_BEGIN+8, TOGGLE_TILE_BEGIN+4);
    val = REFLECT(val, TOGGLE_TILE_BEGIN+9, TOGGLE_TILE_BEGIN+5);

    val = REFLECT_BG(val, 2, 4);
    val = REFLECT_BG(val, 6, 9);
    val = REFLECT_BG(val, 7, 8);
    val = REFLECT_BG(val, 11, 13);
    val = REFLECT_BG(val, 14, 17);
    val = REFLECT_BG(val, 15, 16);
    val = REFLECT_BG(val, 19, 22);
    val = REFLECT_BG(val, 20, 21);
    val = REFLECT_BG(val, 31, 33);

    return val;
}




import flash.events.Event;
import flash.events.MouseEvent;
import flash.filesystem.*;
import flash.net.FileFilter;
import flash.display.MovieClip;
import fl.motion.Color;
import flash.utils.ByteArray;

var bgtiles2:Array = new Array();
var bgtiles:Array = new Array();
var tiles:Array = new Array();
var ftiles2:Array = new Array();
var ftiles3:Array = new Array();
var overlaytiles:Array = new Array();

var sel:Array = null;
var selbegx;
var selbegy;
var selendx;
var selendy;
var selecting = false;

var upwall:Boolean = 0;
var downwall:Boolean = 0;
var leftwall:Boolean = 0;
var rightwall:Boolean  = 0;

var levelvalue:int = 0;

var editbounds_left:int = 0;
var editbounds_right:int = W;
var editbounds_up:int = 0;
var editbounds_down:int = H;

var ldown:Boolean = false;
var rdown:Boolean = false;

var XBEG = 180;//350+140;
var YBEG = 50;//150;
var TILESIZE = 20;
var TILESCALE = TILESIZE/25;
var yy;
var xx;

var foreground_container:MovieClip = new MovieClip();
var background_container:MovieClip = new MovieClip();
var background_container2:MovieClip = new MovieClip();
var foreground_container2:MovieClip = new MovieClip();
var foreground_container3:MovieClip = new MovieClip();
addChild(background_container2);
addChild(background_container);
addChild(foreground_container);
addChild(foreground_container2);
addChild(foreground_container3);

foreground_container.cacheAsBitmap = true;
background_container.cacheAsBitmap = true;
background_container2.cacheAsBitmap = true;
foreground_container2.cacheAsBitmap = true;
foreground_container3.cacheAsBitmap = true;

for( yy = 0; yy<H; yy++){
	bgtiles2[yy] = new Array();
	for( xx = 0; xx<W; xx++){
		
		var btile2 = new Tile();
		btile2.x = TILESIZE*xx + XBEG;
		btile2.y = TILESIZE*yy + YBEG;
		bgtiles2[yy][xx] = btile2;
		background_container2.addChild(btile2);
        btile2.scaleX = TILESCALE;
        btile2.scaleY = TILESCALE;
       // btile.grid.visible = false;
        btile2.cacheAsBitmap = true;
	}
}


for( yy = 0; yy<H; yy++){
	bgtiles[yy] = new Array();
	for( xx = 0; xx<W; xx++){
		
		var btile = new Tile();
		btile.x = TILESIZE*xx + XBEG;
		btile.y = TILESIZE*yy + YBEG;
		bgtiles[yy][xx] = btile;
		background_container.addChild(btile);
        btile.scaleX = TILESCALE;
        btile.scaleY = TILESCALE;
       // btile.grid.visible = false;
        btile.cacheAsBitmap = true;
	}
}

for( yy = 0; yy<H; yy++){
	tiles[yy] = new Array();
	for( xx = 0; xx<W; xx++){
		
		var tile = new Tile();
		tile.x = TILESIZE*xx + XBEG;
		tile.y = TILESIZE*yy + YBEG;
		tiles[yy][xx] = tile;
		foreground_container.addChild(tile);
        tile.scaleX = TILESCALE;
        tile.scaleY = TILESCALE;
        tile.cacheAsBitmap = true;
	}
}

for( yy = 0; yy<H; yy++){
	ftiles2[yy] = new Array();
	for( xx = 0; xx<W; xx++){
		
		var XXXtile = new Tile();
		XXXtile.x = TILESIZE*xx + XBEG;
		XXXtile.y = TILESIZE*yy + YBEG;
		ftiles2[yy][xx] = XXXtile;
		foreground_container2.addChild(XXXtile);
        XXXtile.scaleX = TILESCALE;
        XXXtile.scaleY = TILESCALE;
       // XXXtile.grid.visible = false;
        XXXtile.cacheAsBitmap = true;
	}
}
for( yy = 0; yy<H; yy++){
	ftiles3[yy] = new Array();
	for( xx = 0; xx<W; xx++){
		
		var YYYtile = new Tile();
		YYYtile.x = TILESIZE*xx + XBEG;
		YYYtile.y = TILESIZE*yy + YBEG;
		ftiles3[yy][xx] = YYYtile;
		foreground_container3.addChild(YYYtile);
        YYYtile.scaleX = TILESCALE;
        YYYtile.scaleY = TILESCALE;
        //YYYtile.grid.visible = false;
        YYYtile.cacheAsBitmap = true;
	}
}


var selbounds = new SelBounds();
addChild(selbounds);
selbounds.visible = false;

var selpreview = null;
//addChild(selpreview);

updateWalls(0);

var tt:int;
var tilet;
var xxx:int;
var yyy:int;
var ct:int = 0;

var selmenu_x = 10;

var bt_TILESCALE = .570;

for(tt = BASIC_TILE_BEGIN; tt < BASIC_TILE_BEGIN+BASIC_COUNT; tt++){
	tilet = new eTile();
	xxx = ct % selmenu_x;
	yyy = ct / selmenu_x;
	tilet.x = 30*xxx*bt_TILESCALE + 5;
	tilet.y = 30*yyy*bt_TILESCALE + 80;
    tilet.scaleX = bt_TILESCALE;
    tilet.scaleY = bt_TILESCALE;
	tilet.gotoAndStop(tt);
	addChild(tilet);
	tilet.addEventListener(MouseEvent.CLICK, setBrush);
	ct++;
}
for(tt = TOGGLE_TILE_BEGIN; tt < TOGGLE_TILE_BEGIN+TOGGLE_COUNT; tt++){
	tilet = new eTile();
	xxx = ct % selmenu_x;
	yyy = ct / selmenu_x;
	tilet.x = 30*xxx*bt_TILESCALE + 5;
	tilet.y = 30*yyy*bt_TILESCALE + 80;
    tilet.scaleX = bt_TILESCALE;
    tilet.scaleY = bt_TILESCALE;
	tilet.gotoAndStop(tt);
	addChild(tilet);
	tilet.addEventListener(MouseEvent.CLICK, setBrush);
	ct++;
}
for(tt = TAG_TILE_BEGIN; tt < TAG_TILE_BEGIN+TAG_COUNT; tt++){
	tilet = new eTile();
	xxx = ct % selmenu_x;
	yyy = ct / selmenu_x;
	tilet.x = 30*xxx*bt_TILESCALE + 5;
	tilet.y = 30*yyy*bt_TILESCALE + 80;
    tilet.scaleX = bt_TILESCALE;
    tilet.scaleY = bt_TILESCALE;
	tilet.gotoAndStop(tt);
	addChild(tilet);
	tilet.addEventListener(MouseEvent.CLICK, setBrush);
	ct++;
}
for(tt = OVERLAY_TILE_BEGIN; tt < OVERLAY_TILE_BEGIN+OVERLAY_COUNT; tt++){
	tilet = new eTile();
	xxx = ct % selmenu_x;
	yyy = ct / selmenu_x;
	tilet.x = 30*xxx*bt_TILESCALE + 5;
	tilet.y = 30*yyy*bt_TILESCALE + 80;
    tilet.scaleX = bt_TILESCALE;
    tilet.scaleY = bt_TILESCALE;
	tilet.gotoAndStop(tt);
	addChild(tilet);
	tilet.addEventListener(MouseEvent.CLICK, setBrush);
	ct++;
}

for(tt = ENEMIES_BEGIN; tt < ENEMIES_BEGIN+ENEMY_COUNT; tt++){
	tilet = new eTile();
	xxx = ct % selmenu_x;
	yyy = ct / selmenu_x;
	tilet.x = 30*xxx*bt_TILESCALE + 5;
	tilet.y = 30*yyy*bt_TILESCALE + 80;
    tilet.scaleX = bt_TILESCALE;
    tilet.scaleY = bt_TILESCALE;
	tilet.gotoAndStop(tt);
	addChild(tilet);
	tilet.addEventListener(MouseEvent.CLICK, setBrush);
	ct++;
}

for(tt = BACKGROUND_BEGIN; tt < BACKGROUND_BEGIN+BACKGROUND_COUNT; tt++){
	tilet = new eTile();
	xxx = ct % selmenu_x;
	yyy = ct / selmenu_x;
	tilet.x = 30*xxx*bt_TILESCALE + 5;
	tilet.y = 30*yyy*bt_TILESCALE + 80;
    tilet.scaleX = bt_TILESCALE;
    tilet.scaleY = bt_TILESCALE;
	tilet.gotoAndStop(tt);
	addChild(tilet);
	tilet.addEventListener(MouseEvent.CLICK, setBrush);
	ct++;
}
//1 = foreground, 0 = background
var currentlayer = 1;
var brush = 2;
function setBrush(e:MouseEvent){
	brush = e.target.currentFrame;
	resetBrush();
	//if(IsBG(brush)) currentlayer = 0;
	//else currentlayer = 1;
    currentlayer = GetLayer(brush);
}
resetSel();
resetBrush();

function IsBG(val){
	return val >= BACKGROUND_BEGIN && val <= BACKGROUND_BEGIN+BACKGROUND_COUNT;
}

function GetLayer(val) {
    if(val >= BACKGROUND2_BEGIN && val <= BACKGROUND_BEGIN+BACKGROUND_COUNT) return 4;
    if(val >= BACKGROUND_BEGIN && val <= BACKGROUND_BEGIN+BACKGROUND_COUNT) return 0;
    if(val >= TAG_TILE_BEGIN && val <= TAG_TILE_BEGIN+TAG_COUNT) return 2;
    if(val >= OVERLAY_TILE_BEGIN && val <= OVERLAY_TILE_BEGIN+OVERLAY_COUNT) return 3;
    return 1;
}

var changed = false;



function setTile(mtile_x, mtile_y, val, force = false){
    setSingleTile(mtile_x, mtile_y, val, force);
    if(symmetry.selected){
        setSingleTile(W-mtile_x-1, mtile_y, REFLECT_TILE(val), force);
    }
}

    function setSingleTile(mtile_x, mtile_y, val, force = false){
	//if(!rdown && val==1 && brush!=1 && !force) return;
	
	if(currentlayer==0){
		if(mtile_x >= 0 && mtile_x < W && mtile_y >= 0 && mtile_y < H){
			if(bgtiles[mtile_y][mtile_x].currentFrame != val) changed = true;
			bgtiles[mtile_y][mtile_x].gotoAndStop(val);
		}
	} else if(currentlayer==1) {
		if(mtile_x >= 0 && mtile_x < W && mtile_y >= 0 && mtile_y < H){
			if(tiles[mtile_y][mtile_x].currentFrame != val) changed = true;
			tiles[mtile_y][mtile_x].gotoAndStop(val);
		}
	} else if(currentlayer==2) {
		if(mtile_x >= 0 && mtile_x < W && mtile_y >= 0 && mtile_y < H){
			if(ftiles2[mtile_y][mtile_x].currentFrame != val) changed = true;
			ftiles2[mtile_y][mtile_x].gotoAndStop(val);
		}
	} else if(currentlayer==3) {
		if(mtile_x >= 0 && mtile_x < W && mtile_y >= 0 && mtile_y < H){
			if(ftiles3[mtile_y][mtile_x].currentFrame != val) changed = true;
			ftiles3[mtile_y][mtile_x].gotoAndStop(val);
		}
	} else if(currentlayer==4) {
		if(mtile_x >= 0 && mtile_x < W && mtile_y >= 0 && mtile_y < H){
			if(bgtiles2[mtile_y][mtile_x].currentFrame != val) changed = true;
			bgtiles2[mtile_y][mtile_x].gotoAndStop(val);
		}
	}
}

function rmod(a:int, m:int):int{
	return ((a%m)+m)%m;
}

var floodtouched:Array;
function FloodFill(xbeg:int, ybeg:int, ftiles:Array){
	floodtouched = new Array();
	for( yy = 0; yy<H; yy++){
		floodtouched[yy] = new Array();
		for( xx = 0; xx<W; xx++){
			floodtouched[yy][xx] = false;
		}
	}
	FloodTile(ftiles,ftiles[ybeg][xbeg].currentFrame, xbeg,ybeg, xbeg,ybeg);
}
function FloodTile(ftiles:Array,filltile:int, xcur:int, ycur:int, xbeg:int, ybeg:int ){
	if(ftiles == tiles && !(xcur >= editbounds_left && xcur < editbounds_right && ycur >= editbounds_up && ycur < editbounds_down)) return;
	if(ftiles == bgtiles && !(xcur >= 0 && xcur < W && ycur >= 0 && ycur < H)) return;
    if(ftiles == ftiles2 && !(xcur >= 0 && xcur < W && ycur >= 0 && ycur < H)) return;
    if(ftiles == ftiles3 && !(xcur >= 0 && xcur < W && ycur >= 0 && ycur < H)) return;
    if(ftiles == bgtiles2 && !(xcur >= 0 && xcur < W && ycur >= 0 && ycur < H)) return;
    
	if(floodtouched[ycur][xcur]) return;
	if(ftiles[ycur][xcur].currentFrame != filltile) return;
	
	floodtouched[ycur][xcur] = true;
	
	
	var wx = selendx - selbegx;
	var wy = selendy - selbegy;
	var bx:int = Math.floor(-wx/2+xbeg+1);
	var by:int = Math.floor(-wy/2+ybeg+1);
	var sx = -bx+xcur;
	var sy = -by+ycur;
	
	var val = sel[rmod(sx,wx)][rmod(sy,wy)];
	
	
	if(ftiles[ycur][xcur] != val){
		changed = true;
		ftiles[ycur][xcur].gotoAndStop(val);
	}
	FloodTile(ftiles,filltile,xcur+1,ycur,xbeg,ybeg);
	FloodTile(ftiles,filltile,xcur-1,ycur,xbeg,ybeg);
	FloodTile(ftiles,filltile,xcur,ycur+1,xbeg,ybeg);
	FloodTile(ftiles,filltile,xcur,ycur-1,xbeg,ybeg);
}

var seldragging = false;

function update(e:Event){

	if(selpreview != null && sel == null){
		removeChild(selpreview);
		selpreview = null;
	}
	
	if(currentlayer==0){
		var c:Color = new Color();
		c.setTint(0x00FFFF, 0.1);
		foreground_container.transform.colorTransform = c;
		foreground_container.alpha = .7;
        
        foreground_container2.alpha = .2;
        foreground_container3.alpha = .2;
        background_container.alpha = 1;
	} else if(currentlayer==1){
		foreground_container.alpha = 1;
		var c:Color = new Color();
		foreground_container.transform.colorTransform = c;
        
        foreground_container2.alpha = .4;
        foreground_container3.alpha = .4;
        background_container.alpha = 1;
	} else if(currentlayer==2){
		foreground_container.alpha = 1;
		var c:Color = new Color();
        c.setTint(0xFFFFFF, 0.2);
		foreground_container.transform.colorTransform = c;
        
        foreground_container2.alpha = 1;
        foreground_container3.alpha = .4;
        background_container.alpha = 1;
	} else if(currentlayer==3){
		foreground_container.alpha = 1;
		var c:Color = new Color();
        c.setTint(0xFFFFFF, 0.2);
		foreground_container.transform.colorTransform = c;
        
        foreground_container2.alpha = .4;
        foreground_container3.alpha = 1;
        background_container.alpha = 1;
	} else if(currentlayer==4){
		var c:Color = new Color();
		c.setTint(0x00FFFF, 0.1);
		foreground_container.transform.colorTransform = c;
		foreground_container.alpha = .7;
        
        foreground_container2.alpha = .2;
        foreground_container3.alpha = .2;
        background_container.alpha = .2;
	}
	
	var mtile_x:int = Math.floor((mouseX - XBEG)/TILESIZE);
	var mtile_y:int = Math.floor((mouseY - YBEG)/TILESIZE);
	
	
	if(!seldragging){
	    selbounds.visible = false;
	    if(selpreview) selpreview.visible = false;
	    if(ldown){
	        if(sel == null){
	            setTile(mtile_x, mtile_y, brush);
	        } else {
	            var wx = sel.length;//selendx - selbegx;
	            var wy = sel[0].length;//selendy - selbegy;
				
	            var bx:int = Math.floor(-wx/2+mtile_x+1);
	            var by:int = Math.floor(-wy/2+mtile_y+1);
				
	            for(var i = 0; i<wx; i++){
	                for(var j = 0; j<wy; j++){
	                    setTile(bx + i, by + j, sel[i][j]);
	                }
	            }
	        }
	    } else if(rdown){
	        setTile(mtile_x, mtile_y, 1);
	    } else {
	        if(selpreview){
	            var wx = sel.length;//selendx - selbegx;
	            var wy = sel[0].length;//selendy - selbegy;
				
	            var bx:int = Math.floor(-wx/2+mtile_x+1);
	            var by:int = Math.floor(-wy/2+mtile_y+1);
				
	            selpreview.visible = true;
	            selpreview.x = bx*TILESIZE+XBEG;
	            selpreview.y = by*TILESIZE+YBEG;
	        }
	    }
	}
	if(selecting){
		selbounds.visible = true;
		
		var selbegx2 = selbegx;
		var selbegy2 = selbegy;
		
		if(seldragging){
			selendx = mtile_x;
			selendy = mtile_y;
		}
		
		var selendx2 = selendx;
		var selendy2 = selendy;
			
		if(selendx2 < selbegx2){
			var temp = selbegx2;
			selbegx2 = selendx2;
			selendx2 = temp;
		}
		if(selendy2 < selbegy2){
			var temp = selbegy2;
			selbegy2 = selendy2;
			selendy2 = temp;
		}

		selbounds.x = selbegx2*TILESIZE+ XBEG;
		selbounds.y = selbegy2*TILESIZE+ YBEG;
		
		selbounds.width = (selendx2+1 - selbegx2)*TILESIZE;
		selbounds.height = (selendy2+1 - selbegy2)*TILESIZE;
	}
	
	stage.focus = null;
}

function updateWalls(walldata:int){
    return;
    
    changed = true;
	
	levelvalue = walldata;
    if(walldata == 100) walldata = 4;
	if(walldata == 101) walldata = 4;
    if(walldata == 102) walldata = 12;
    
	upwall = walldata & 8;
	downwall = walldata & 4;
	leftwall = walldata & 2;
    rightwall  = walldata & 1;
	
	lopen.visible = !leftwall;
	ropen.visible = !rightwall;
	uopen.visible = !upwall;
	dopen.visible = !downwall;
	
	
	for(var i = 0; i<H; i++){
		tiles[i][0].gotoAndStop(1);
		tiles[i][W-1].gotoAndStop(1);
	}
	for(var i = 0; i<W; i++){
		tiles[0][i].gotoAndStop(2);
		tiles[H-1][i].gotoAndStop(2);
		
		if(i >= 11 && i <= 15){
			tiles[0][i].gotoAndStop(1);
			tiles[H-1][i].gotoAndStop(1);
		}
	}
	
    editbounds_left = 0;
    editbounds_right = W;
	
	if(upwall){
		for(var i = 0; i<W; i++){
			tiles[0][i].gotoAndStop(2);
		}
	}
	
	if(downwall){
		for(var i = 0; i<W; i++){
			tiles[H-1][i].gotoAndStop(2);
		}
	}
	
	if(leftwall){
		for(var i = 0; i<H; i++){
			tiles[i][0].gotoAndStop(2);
		}
		editbounds_left = 1;
	}
	
	if(rightwall){
		for(var i = 0; i<H; i++){
			tiles[i][W-1].gotoAndStop(2);
		}
		editbounds_right = W-1;
	}
	
	
}

function updateWallsEvent(e:Event){
	var walldata:int = parseInt(walls.value, 10);
	updateWalls(walldata);
	
	stage.focus = null;
	
}

addEventListener(Event.ENTER_FRAME, update);
walls.addEventListener(Event.CHANGE, updateWallsEvent);



function e_ldown(e:MouseEvent){
    var mtile_x:int = Math.floor((mouseX - XBEG)/TILESIZE);
    var mtile_y:int = Math.floor((mouseY - YBEG)/TILESIZE);
    rdown = false;
    if(mtile_x > -3){
        ldown = true;
        //selecting = false;
        //resetSel();

        if(!kCtrl){
            resetBrush();

            if(kShift){
                var mtile_x:int = Math.floor((mouseX - XBEG)/TILESIZE);
                var mtile_y:int = Math.floor((mouseY - YBEG)/TILESIZE);
                if(mtile_x < 0) mtile_x = 0;
                if(mtile_y < 0) mtile_y = 0;
                if(mtile_x >W-1) mtile_x = W-1;
                if(mtile_y >H-1) mtile_y = H-1;
		
                selbegx = mtile_x;
                selbegy = mtile_y;
		
                //sel = null;
                //resetSel();
                seldragging = true;
                selecting = true;
            } else {
                //selecting = false;
            }
        }
    }
}
function e_lup(e:MouseEvent){
	ldown = false;
	
	if(changed){
		PushUndo();
		changed = false;
	}
	
	if(selecting && seldragging){
	    seldragging = false;
	    resetBrush();
		return;
		
		var mtile_x:int = Math.floor((mouseX - XBEG)/TILESIZE);
		var mtile_y:int = Math.floor((mouseY - YBEG)/TILESIZE);
		
		selendx = mtile_x;
		selendy = mtile_y;
		
		if(selendx < selbegx){
			var temp = selbegx;
			selbegx = selendx;
			selendx = temp;
		}
		if(selendy < selbegy){
			var temp = selbegy;
			selbegy = selendy;
			selendy = temp;
		}
		
		if(selendx - selbegx >0 || selendy - selbegy > 0){
			selendx += 1;
			selendy += 1;
			
			var wx = selendx - selbegx;
			var wy = selendy - selbegy;
			
			sel = new Array();
			for(var i = 0; i<wx; i++){
				sel[i]= new Array();
				for(var j = 0; j<wy; j++){
					if(currentlayer==0){
						sel[i][j] = bgtiles[j+selbegy][i+selbegx].currentFrame;
					} else if(currentlayer==1){
						sel[i][j] = tiles[j+selbegy][i+selbegx].currentFrame;
					} else if(currentlayer==2){
						sel[i][j] = ftiles2[j+selbegy][i+selbegx].currentFrame;
					} else if(currentlayer==3){
						sel[i][j] = ftiles3[j+selbegy][i+selbegx].currentFrame;
					} else if(currentlayer==4){
						sel[i][j] = bgtiles2[j+selbegy][i+selbegx].currentFrame;
					}
				}
			}

			if(selpreview){
				removeChild(selpreview);
			}
			selpreview = new MovieClip();
			addChild(selpreview);
			
			for(var i = 0; i<wx; i++){
				for(var j = 0; j<wy; j++){
					var seltile = new Tile();
					seltile.x = i*TILESIZE;
					seltile.y = j*TILESIZE;
					seltile.gotoAndStop(sel[i][j]);
					selpreview.addChild(seltile);
                    seltile.scaleX = TILESCALE;
                    seltile.scaleY = TILESCALE;
					
					seltile.addEventListener(Event.ENTER_FRAME, selBoundsHide, false, 0, true);
				}
			}
			var c:Color = new Color();
			c.setTint(0x00FF00, 0.3);
			selpreview.transform.colorTransform = c;
		} else {
			resetSel();
		}
		
		selecting = false;
	}
}

function resetSel(){
	if(selpreview){
		removeChild(selpreview);
	}
	
	sel = new Array();
	sel[0]= new Array();
	sel[0][0] = brush;
	
	
	selpreview = new MovieClip();
	addChild(selpreview);
	var seltile = new Tile();
	selpreview.addChild(seltile);
	seltile.gotoAndStop(brush);
	seltile.addEventListener(Event.ENTER_FRAME, selBoundsHide, false, 0, true);
    seltile.scaleX = TILESCALE;
    seltile.scaleY = TILESCALE;
	var c:Color = new Color();
	c.setTint(0x00FF00, 0.3);
	selpreview.transform.colorTransform = c;
	
	selbegx = 0;
	selbegy = 0;
	selendx = 1;
	selendy = 1;
}

function resetBrush(){
    if(selpreview){
        removeChild(selpreview);
    }
	
    sel = new Array();
    sel[0]= new Array();
    sel[0][0] = brush;
	
	
    selpreview = new MovieClip();
    addChild(selpreview);
    var seltile = new Tile();
    selpreview.addChild(seltile);
    seltile.gotoAndStop(brush);
    seltile.addEventListener(Event.ENTER_FRAME, selBoundsHide, false, 0, true);
    
    seltile.scaleX = TILESCALE;
    seltile.scaleY = TILESCALE;
    var c:Color = new Color();
    c.setTint(0x00FF00, 0.3);
    selpreview.transform.colorTransform = c;
}

function selBoundsHide(e:Event){
	if(selpreview){
		var sx:int = ((e.target.x + selpreview.x)-XBEG)/TILESIZE;
		var sy:int = ((e.target.y + selpreview.y)-YBEG)/TILESIZE;
		
		if(sx < 0 || sx >= W || sy < 0 || sy >= H || seldragging){
			e.target.visible = false;
		} else {
			e.target.visible = true;
		}
		
	}
}



function e_rdown(e:MouseEvent){
    if(!selecting){
        rdown = true;
    }
	ldown = false;

	selecting = false;
	resetSel();
}
function e_rup(e:MouseEvent){
	if(changed){
		PushUndo();
		changed = false;
	}
	rdown = false;
}
stage.addEventListener(MouseEvent.MOUSE_DOWN, e_ldown);
stage.addEventListener(MouseEvent.MOUSE_UP, e_lup);

stage.addEventListener(MouseEvent.RIGHT_MOUSE_DOWN, e_rdown);
stage.addEventListener(MouseEvent.RIGHT_MOUSE_UP, e_rup);

stage.addEventListener(MouseEvent.MOUSE_WHEEL, onMouseWheelEvent);
function onMouseWheelEvent(e:MouseEvent){
	if(e.delta > 0){
		brush += 1;
		if(brush == BASIC_TILE_BEGIN+BASIC_COUNT){
			brush = TOGGLE_TILE_BEGIN;
		}
		if(brush == TOGGLE_TILE_BEGIN+TOGGLE_COUNT){
			brush = TAG_TILE_BEGIN;
		}
        if(brush == TAG_TILE_BEGIN+TAG_COUNT){
			brush = OVERLAY_TILE_BEGIN;
		}
        if(brush == OVERLAY_TILE_BEGIN+OVERLAY_COUNT){
			brush = ENEMIES_BEGIN;
		}
		if(brush == ENEMIES_BEGIN+ENEMY_COUNT){
			brush = BACKGROUND_BEGIN;
		}
		if(brush == BACKGROUND_BEGIN+BACKGROUND_COUNT){
			brush = BASIC_TILE_BEGIN;
		}
	}
	
	if(e.delta < 0){
		brush -= 1;
		if(brush == BASIC_TILE_BEGIN-1){
			brush = BACKGROUND_BEGIN+BACKGROUND_COUNT-1;
		}
		if(brush == TOGGLE_TILE_BEGIN-1){
			brush = BASIC_TILE_BEGIN+BASIC_COUNT-1;
		}
        if(brush == TAG_TILE_BEGIN-1){
			brush = TOGGLE_TILE_BEGIN+TOGGLE_COUNT-1;
		}
        if(brush == OVERLAY_TILE_BEGIN-1){
			brush = TAG_TILE_BEGIN+TAG_COUNT-1;
		}
		if(brush == ENEMIES_BEGIN-1){
			brush = OVERLAY_TILE_BEGIN+OVERLAY_COUNT-1;
		}
		if(brush == BACKGROUND_BEGIN-1){
			brush = ENEMIES_BEGIN+ENEMY_COUNT-1;
		}
	}
	
	//if(IsBG(brush)) currentlayer = 0;
	//else currentlayer = 1;
    
    currentlayer = GetLayer(brush);
	
    //resetSel();
	resetBrush();
}

function ShiftLeft(){
    
    for(var px = 0; px < W; px++){
        for(var py = 0; py < H; py++){
            if(px == W-1){
                bgtiles[py][px].gotoAndStop(0);
                tiles[py][px].gotoAndStop(0);
                ftiles2[py][px].gotoAndStop(0);
                ftiles3[py][px].gotoAndStop(0);
                bgtiles2[py][px].gotoAndStop(0);
            } else {
                bgtiles[py][px].gotoAndStop(bgtiles[py][px+1].currentFrame);
                tiles[py][px].gotoAndStop(tiles[py][px+1].currentFrame);
                ftiles2[py][px].gotoAndStop(ftiles2[py][px+1].currentFrame);
                ftiles3[py][px].gotoAndStop(ftiles3[py][px+1].currentFrame);
                bgtiles2[py][px].gotoAndStop(bgtiles2[py][px+1].currentFrame);
            }
        }
    }
    
    changed = true;
}

function ShiftRight(){
    
    for(var px = W-1; px >= 0; px--){
        for(var py = 0; py < H; py++){
            if(px == 0){
                bgtiles[py][px].gotoAndStop(0);
                tiles[py][px].gotoAndStop(0);
                ftiles2[py][px].gotoAndStop(0);
                ftiles3[py][px].gotoAndStop(0);
                bgtiles2[py][px].gotoAndStop(0);
            } else {
                bgtiles[py][px].gotoAndStop(bgtiles[py][px-1].currentFrame);
                tiles[py][px].gotoAndStop(tiles[py][px-1].currentFrame);
                ftiles2[py][px].gotoAndStop(ftiles2[py][px-1].currentFrame);
                ftiles3[py][px].gotoAndStop(ftiles3[py][px-1].currentFrame);
                bgtiles2[py][px].gotoAndStop(bgtiles2[py][px-1].currentFrame);
            }
        }
    }
    
    changed = true;
}


function ShiftUp(){
    
    for(var px = 0; px < W; px++){
        for(var py = 0; py < H; py++){
            if(py == H-1){
                bgtiles[py][px].gotoAndStop(0);
                tiles[py][px].gotoAndStop(0);
                ftiles2[py][px].gotoAndStop(0);
                ftiles3[py][px].gotoAndStop(0);
                bgtiles2[py][px].gotoAndStop(0);
            } else {
                bgtiles[py][px].gotoAndStop(bgtiles[py+1][px].currentFrame);
                tiles[py][px].gotoAndStop(tiles[py+1][px].currentFrame);
                ftiles2[py][px].gotoAndStop(ftiles2[py+1][px].currentFrame);
                ftiles3[py][px].gotoAndStop(ftiles3[py+1][px].currentFrame);
                bgtiles2[py][px].gotoAndStop(bgtiles2[py+1][px].currentFrame);
            }
        }
    }
    
    changed = true;
}

function ShiftDown(){
    
    for(var px = 0; px < W; px++){
        for(var py = H-1; py >= 0; py--){
            if(py == 0){
                bgtiles[py][px].gotoAndStop(0);
                tiles[py][px].gotoAndStop(0);
                ftiles2[py][px].gotoAndStop(0);
                ftiles3[py][px].gotoAndStop(0);
                bgtiles2[py][px].gotoAndStop(0);
            } else {
                bgtiles[py][px].gotoAndStop(bgtiles[py-1][px].currentFrame);
                tiles[py][px].gotoAndStop(tiles[py-1][px].currentFrame);
                ftiles2[py][px].gotoAndStop(ftiles2[py-1][px].currentFrame);
                ftiles3[py][px].gotoAndStop(ftiles3[py-1][px].currentFrame);
                bgtiles2[py][px].gotoAndStop(bgtiles2[py-1][px].currentFrame);
            }
        }
    }
    
    changed = true;
}

var kShift:Boolean = false;
var kCtrl:Boolean = false;
function kdown(e:KeyboardEvent){
	if (e.keyCode == 16) { //shift
		kShift = true;
	}
	if (e.keyCode == 27) { //esc
        if(currentlayer == 0) brush = BACKGROUND_BEGIN;
        if(currentlayer == 1) brush = 2;
        if(currentlayer == 2) brush = TAG_TILE_BEGIN;
        if(currentlayer == 3) brush = OVERLAY_TILE_BEGIN;
        if(currentlayer == 4) brush = BACKGROUND2_BEGIN+8;
		//brush = currentlayer?2:BACKGROUND_BEGIN;
		resetSel();
		selecting = false;
	}
	if (e.ctrlKey) { //ctrl
		if(e.keyCode == 90){
			PopUndo();
		}
		if(e.keyCode == 89){
			PopRedo();
		}
        
        if(e.keyCode == 37){ //left arrow
            ShiftLeft();
        }
        if(e.keyCode == 38){ //up arrow
            ShiftUp();
        }
        if(e.keyCode == 39){ //right arrow
            ShiftRight();
        }
        if(e.keyCode == 40){ //down arrow
            ShiftDown();
        }
	}

	if (e.keyCode == 17 && !kCtrl && selecting) { //ctrl
	    kCtrl = true;
	    var selbegx2 = selbegx;
	    var selbegy2 = selbegy;
		
	    var selendx2 = selendx;
	    var selendy2 = selendy;
			
	    if(selendx2 < selbegx2){
	        var temp = selbegx2;
	        selbegx2 = selendx2;
	        selendx2 = temp;
	    }
	    if(selendy2 < selbegy2){
	        var temp = selbegy2;
	        selbegy2 = selendy2;
	        selendy2 = temp;
	    }
			
	    if(selendx2 - selbegx2 >0 || selendy2 - selbegy2 > 0){
	        selendx2 += 1;
	        selendy2 += 1;

	        var wx = selendx2 - selbegx2;
	        var wy = selendy2 - selbegy2;

	        sel = new Array();
	        for(var i = 0; i<wx; i++){
	            sel[i]= new Array();
	            for(var j = 0; j<wy; j++){
	                if(currentlayer==0){
	                    sel[i][j] = bgtiles[j+selbegy2][i+selbegx2].currentFrame;
	                } else if(currentlayer==1){
	                    sel[i][j] = tiles[j+selbegy2][i+selbegx2].currentFrame;
	                } else if(currentlayer==2){
	                    sel[i][j] = ftiles2[j+selbegy2][i+selbegx2].currentFrame;
	                } else if(currentlayer==3){
	                    sel[i][j] = ftiles3[j+selbegy2][i+selbegx2].currentFrame;
	                } else if(currentlayer==4){
	                    sel[i][j] = bgtiles2[j+selbegy2][i+selbegx2].currentFrame;
	                }
	            }
	        }

	        if(selpreview){
	            removeChild(selpreview);
	        }
	        selpreview = new MovieClip();
	        addChild(selpreview);
			
	        for(var i = 0; i<wx; i++){
	            for(var j = 0; j<wy; j++){
	                var seltile = new Tile();
	                seltile.x = i*TILESIZE;
	                seltile.y = j*TILESIZE;
	                seltile.gotoAndStop(sel[i][j]);
	                selpreview.addChild(seltile);
                    seltile.scaleX = TILESCALE;
	                seltile.scaleY = TILESCALE;
					
	                seltile.addEventListener(Event.ENTER_FRAME, selBoundsHide, false, 0, true);
	            }
	        }
	        var c:Color = new Color();
	        c.setTint(0x00FF00, 0.3);
	        selpreview.transform.colorTransform = c;
	    }
	}
	
	if (e.keyCode == 71) { //G
		var mtile_x:int = Math.floor((mouseX - XBEG)/TILESIZE);
		var mtile_y:int = Math.floor((mouseY - YBEG)/TILESIZE);
		
		if(mtile_x>=0 && mtile_x<W && mtile_y>=0 &&mtile_y<H){
			if(currentlayer==0){
				brush = bgtiles[mtile_y][mtile_x].currentFrame;
				resetBrush();
			} else if(currentlayer==1){
				brush = tiles[mtile_y][mtile_x].currentFrame;
				resetBrush();
			} else if(currentlayer==2){
				brush = ftiles2[mtile_y][mtile_x].currentFrame;
				resetBrush();
			} else if(currentlayer==3){
				brush = ftiles3[mtile_y][mtile_x].currentFrame;
				resetBrush();
			} else if(currentlayer==4){
				brush = bgtiles2[mtile_y][mtile_x].currentFrame;
				resetBrush();
			}
		}
		
	}
	
	if (e.keyCode == 70 || e.keyCode == 8 || e.keyCode == 46) { //F
		var mtile_x:int = Math.floor((mouseX - XBEG)/TILESIZE);
		var mtile_y:int = Math.floor((mouseY - YBEG)/TILESIZE);
		
		if(selecting){
			
			
			
			//var mtile_x:int = Math.floor((mouseX - XBEG)/25);
			//var mtile_y:int = Math.floor((mouseY - YBEG)/25);
			
		    var selbegx2 = selbegx;
		    var selbegy2 = selbegy;
		
		    var selendx2 = selendx;
		    var selendy2 = selendy;
			
		    if(selendx2 < selbegx2){
		        var temp = selbegx2;
		        selbegx2 = selendx2;
		        selendx2 = temp;
		    }
		    if(selendy2 < selbegy2){
		        var temp = selbegy2;
		        selbegy2 = selendy2;
		        selendy2 = temp;
		    }
			
			if(selendx2 - selbegx2 >0 || selendy2 - selbegy2 > 0){
				selendx2 += 1;
				selendy2 += 1;
				
				var wx = selendx2 - selbegx2;
				var wy = selendy2 - selbegy2;
				
				for(var i = 0; i<wx; i++){
					for(var j = 0; j<wy; j++){
					    setTile(i+selbegx2, j+selbegy2, e.keyCode == 70?brush:1, true);
					}
				}
			}
			
			//selecting = false;
			//ldown = false;
			//resetSel();
			
		} else if(e.keyCode == 70) {
		
			if(mtile_x>=0 && mtile_x<W && mtile_y>=0 &&mtile_y<H){
				if(currentlayer==0){
					FloodFill(mtile_x, mtile_y, bgtiles);
				} else if(currentlayer==1){
					FloodFill(mtile_x, mtile_y, tiles);
				} else if(currentlayer==2){
					FloodFill(mtile_x, mtile_y, ftiles2);
				} else if(currentlayer==3){
					FloodFill(mtile_x, mtile_y, ftiles3);
				} else if(currentlayer==4){
					FloodFill(mtile_x, mtile_y, bgtiles2);
				}
			}
		}
		
	}
    
    if(changed){
        PushUndo();
        changed = false;
    }
	
	
}
function kup(e:KeyboardEvent){
	if (e.keyCode == 16) { //shift
		kShift = false;
	}

    if (e.keyCode == 17) { //ctrl
        resetBrush();
        kCtrl = false;
	}
}
stage.addEventListener(KeyboardEvent.KEY_DOWN, kdown);
stage.addEventListener(KeyboardEvent.KEY_UP, kup);


var pastfile:File = null;

//save file
function savefile(e:MouseEvent){
	var savedir:File = File.applicationDirectory;
    savedir.nativePath += "/../prototype/tilemaps";
	if(pastfile != null) savedir = pastfile.clone();
	savedir.browseForSave("Save Room"/*, [new FileFilter("Levels", "*.txt")]*/);
	savedir.addEventListener(Event.SELECT, saveData);
}
function openfile(e:MouseEvent){
	var savedir:File = File.applicationDirectory;
    savedir.nativePath += "/../prototype/tilemaps";
	savedir.browseForOpen("Load Room", [new FileFilter("Levels", "*.lvl")]);
	savedir.addEventListener(Event.SELECT, loadData);
}


function saveData(e:Event){
	trace("save!");
	var filename = e.target;
	if(filename.extension != "lvl"){
		var counter:int = 0;
		var newf;
		do {
			counter++;
			if(counter < 2){
		    	newf = new File(filename.url+".lvl");
			} else {
				newf = new File(filename.url+"("+counter+").lvl");	
			}
		} while(newf.exists);
		
		if(counter < 2){
			filename.url = (filename.url+".lvl");
		} else {
			filename.url = (filename.url+"("+counter+").lvl");	
		}
	}
	
	pastfile = filename;
	
	trace(filename.url);

	var stream:FileStream = new FileStream();
    stream.open(filename, FileMode.WRITE);
	
	stream.writeInt(1);  //version
	stream.writeInt(W); //width
	stream.writeInt(H); //height
	stream.writeInt(5); //numlayers
	
	for(var yy = 0; yy<H; yy++){
		for(var xx = 0; xx<W; xx++){
			var frame1:uint = Frame_To_Save_Index(bgtiles[yy][xx].currentFrame);
			stream.writeUnsignedInt(frame1);
		}
	}
    for(var yy = 0; yy<H; yy++){
		for(var xx = 0; xx<W; xx++){
			var frame1 = Frame_To_Save_Index(tiles[yy][xx].currentFrame);
			stream.writeUnsignedInt(frame1);
		}
	}
    for(var yy = 0; yy<H; yy++){
		for(var xx = 0; xx<W; xx++){
			var frame1 = Frame_To_Save_Index(ftiles2[yy][xx].currentFrame);
			stream.writeUnsignedInt(frame1);
		}
	}
    for(var yy = 0; yy<H; yy++){
		for(var xx = 0; xx<W; xx++){
			var frame1 = Frame_To_Save_Index(ftiles3[yy][xx].currentFrame);
			stream.writeUnsignedInt(frame1);
		}
	}
	for(var yy = 0; yy<H; yy++){
		for(var xx = 0; xx<W; xx++){
			var frame1 = Frame_To_Save_Index(bgtiles2[yy][xx].currentFrame);
			stream.writeUnsignedInt(frame1);
		}
	}
	//extra data
	//stream.writeInt(difficulty.value);
	
	stream.close();
	
	
	
	//save last saved filename somewhere
	var dir = filename.url;
	var lastslash = dir.lastIndexOf("/");
	var subdir = dir.substr(0, lastslash+1);
	trace(subdir);
	
	var txtfiler = subdir + "/lastsaved.txt";
	var stream:FileStream = new FileStream();
    stream.open(new File(txtfiler), FileMode.WRITE);
	stream.writeUTFBytes(filename.name+"\n");
	stream.writeUTFBytes("default.lvl");
	stream.close();
}

function Save_Index_To_Frame(saveIndex:uint){
	if(saveIndex >= BACKGROUND_BEGIN_SAVEFILE) return saveIndex-BACKGROUND_BEGIN_SAVEFILE+BACKGROUND_BEGIN;
	if(saveIndex >= ENEMIES_BEGIN_SAVEFILE) return saveIndex-ENEMIES_BEGIN_SAVEFILE+ENEMIES_BEGIN;
    if(saveIndex >= OVERLAY_TILE_BEGIN_SAVEFILE) return saveIndex-OVERLAY_TILE_BEGIN_SAVEFILE+OVERLAY_TILE_BEGIN;
    if(saveIndex >= TAG_TILE_BEGIN_SAVEFILE) return saveIndex-TAG_TILE_BEGIN_SAVEFILE+TAG_TILE_BEGIN;
	if(saveIndex >= TOGGLE_TILE_BEGIN_SAVEFILE) return saveIndex-TOGGLE_TILE_BEGIN_SAVEFILE+TOGGLE_TILE_BEGIN;
	if(saveIndex >= BASIC_TILE_BEGIN_SAVEFILE) return saveIndex-BASIC_TILE_BEGIN_SAVEFILE+BASIC_TILE_BEGIN;
}
function Frame_To_Save_Index(frame:uint){
	if(frame >= BACKGROUND_BEGIN) return frame+BACKGROUND_BEGIN_SAVEFILE-BACKGROUND_BEGIN;
	if(frame >= ENEMIES_BEGIN) return frame+ENEMIES_BEGIN_SAVEFILE-ENEMIES_BEGIN;
    if(frame >= OVERLAY_TILE_BEGIN) return frame+OVERLAY_TILE_BEGIN_SAVEFILE-OVERLAY_TILE_BEGIN;
    if(frame >= TAG_TILE_BEGIN) return frame+TAG_TILE_BEGIN_SAVEFILE-TAG_TILE_BEGIN;
	if(frame >= TOGGLE_TILE_BEGIN) return frame+TOGGLE_TILE_BEGIN_SAVEFILE-TOGGLE_TILE_BEGIN;
	if(frame >= BASIC_TILE_BEGIN) return frame+BASIC_TILE_BEGIN_SAVEFILE-BASIC_TILE_BEGIN;
}

function loadData(e:Event){
	trace("load!");
	
	
	var stream:FileStream = new FileStream();
	var filename = e.target;
	pastfile = filename;
	
    stream.open(filename, FileMode.READ);
	
	stream.readInt(); //version
	stream.readInt(); //width
	stream.readInt(); //height
	//levelvalue = stream.readInt(); //wallsdata
	//walls.selectedIndex = levelvalue;
	//updateWalls(levelvalue);
    var nlayers:int = stream.readInt(); //numlayers
	
    for(var yy = 0; yy<H; yy++){
		for(var xx = 0; xx<W; xx++){
			var val:uint = stream.readUnsignedInt();
			bgtiles[yy][xx].gotoAndStop(Save_Index_To_Frame(val));
		}
	}
	for(var yy = 0; yy<H; yy++){
		for(var xx = 0; xx<W; xx++){
			var val:uint = stream.readUnsignedInt();
			tiles[yy][xx].gotoAndStop(Save_Index_To_Frame(val));
		}
	}
    for(var yy = 0; yy<H; yy++){
		for(var xx = 0; xx<W; xx++){
			var val:uint = stream.readUnsignedInt();
			ftiles2[yy][xx].gotoAndStop(Save_Index_To_Frame(val));
		}
	}
    for(var yy = 0; yy<H; yy++){
		for(var xx = 0; xx<W; xx++){
			var val:uint = stream.readUnsignedInt();
			ftiles3[yy][xx].gotoAndStop(Save_Index_To_Frame(val));
		}
	}
    if(nlayers == 4){
        for(var yy = 0; yy<H; yy++){
            for(var xx = 0; xx<W; xx++){
                bgtiles2[yy][xx].gotoAndStop(Save_Index_To_Frame(0));
            }
        }
    } else {
        for(var yy = 0; yy<H; yy++){
            for(var xx = 0; xx<W; xx++){
                var val:uint = stream.readUnsignedInt();
                bgtiles2[yy][xx].gotoAndStop(Save_Index_To_Frame(val));
            }
        }
    }
	
	//difficulty.value = stream.readInt();
	stream.close();
	
	undostack = new Array();
    redostack = new Array();
	changed = false;
    PushUndo();
}


open.addEventListener(MouseEvent.CLICK, openfile);
save.addEventListener(MouseEvent.CLICK, savefile);
clear.addEventListener(MouseEvent.CLICK, clearLevel);
exexe.addEventListener(MouseEvent.CLICK, LaunchGame);

layertoggle_1.addEventListener(MouseEvent.CLICK, function(MouseEvent){brush = 2;currentlayer = 1;resetSel();});
layertoggle_0.addEventListener(MouseEvent.CLICK, function(MouseEvent){brush = BACKGROUND_BEGIN;currentlayer = 0;resetSel();});

function clearLevel(e:MouseEvent){
    resetSel();
    selecting = false;

	for(var yy = 0; yy<H; yy++){
		for(var xx = 0; xx<W; xx++){
			tiles[yy][xx].gotoAndStop(1);
			bgtiles[yy][xx].gotoAndStop(1);
            bgtiles2[yy][xx].gotoAndStop(1);
            ftiles2[yy][xx].gotoAndStop(1);
            ftiles3[yy][xx].gotoAndStop(1);
		}
	}
	updateWalls(levelvalue);
    
    changed = true;
}


//undo stack
var undostack:Array = new Array();
var redostack:Array = new Array();

function PushUndo(){
	trace("pushed undo");
	var dat:ByteArray = new ByteArray();
	
	dat.writeInt(levelvalue); //wallsdata
	for(var yy = 0; yy<H; yy++){
		for(var xx = 0; xx<W; xx++){
			var frame1 = Frame_To_Save_Index(tiles[yy][xx].currentFrame);
			var frame2 = Frame_To_Save_Index(bgtiles[yy][xx].currentFrame);
            var frame3 = Frame_To_Save_Index(ftiles2[yy][xx].currentFrame);
            var frame4 = Frame_To_Save_Index(ftiles3[yy][xx].currentFrame);
            var frame5 = Frame_To_Save_Index(bgtiles2[yy][xx].currentFrame);
			dat.writeInt(frame1);
            dat.writeInt(frame2);
            dat.writeInt(frame3);
            dat.writeInt(frame4);
            dat.writeInt(frame5);
		}
	}
	
	undostack.push(dat);
	redostack = new Array();
	
	if(undostack.length > 256) undostack.shift();
}
function PopUndo(){
	if(undostack.length >= 2){
		redostack.push(undostack.pop()); //current design
		var dat:ByteArray = undostack[undostack.length-1]; //previous design
		dat.position = 0;
		
		levelvalue = dat.readInt(); //wallsdata
		walls.selectedIndex = levelvalue;
		updateWalls(levelvalue);
		
		for(var yy = 0; yy<H; yy++){
			for(var xx = 0; xx<W; xx++){
				var val1:int = dat.readInt();
                var val2:int = dat.readInt();
                var val3:int = dat.readInt();
                var val4:int = dat.readInt();
                var val5:int = dat.readInt();
				tiles[yy][xx].gotoAndStop(Save_Index_To_Frame(val1));
				bgtiles[yy][xx].gotoAndStop(Save_Index_To_Frame(val2));
                ftiles2[yy][xx].gotoAndStop(Save_Index_To_Frame(val3));
                ftiles3[yy][xx].gotoAndStop(Save_Index_To_Frame(val4));
                bgtiles2[yy][xx].gotoAndStop(Save_Index_To_Frame(val5));
			}
		}
		
	} else {
		/*if(undostack.length >= 1){
			redostack.push(undostack.pop());
		}
		undostack = new Array();
		clearLevel(null);*/
	}
	
	changed = false;
}
function PopRedo(){
	if(redostack.length >= 1){
		var dat:ByteArray = redostack.pop(); //previous design
		dat.position = 0;
		
		levelvalue = dat.readInt(); //wallsdata
		walls.selectedIndex = levelvalue;
		updateWalls(levelvalue);
		
		for(var yy = 0; yy<H; yy++){
			for(var xx = 0; xx<W; xx++){
				var val1:int = dat.readInt();
                var val2:int = dat.readInt();
                var val3:int = dat.readInt();
                var val4:int = dat.readInt();
                var val5:int = dat.readInt();
				tiles[yy][xx].gotoAndStop(Save_Index_To_Frame(val1));
				bgtiles[yy][xx].gotoAndStop(Save_Index_To_Frame(val2));
                ftiles2[yy][xx].gotoAndStop(Save_Index_To_Frame(val3));
                ftiles3[yy][xx].gotoAndStop(Save_Index_To_Frame(val4));
                bgtiles2[yy][xx].gotoAndStop(Save_Index_To_Frame(val5));
			}
		}
		
		undostack.push(dat);
		//PushUndo();
		changed = false;
	}
}

var process:NativeProcess;
function LaunchGame(e:MouseEvent){
    var file:File = File.applicationDirectory;
    file.nativePath += "/../prototype/TheEnd.exe";

    var wkdir:File = File.applicationDirectory;
    wkdir.nativePath += "/../prototype";

    trace(file.nativePath);

    var nativeProcessStartupInfo:NativeProcessStartupInfo = new NativeProcessStartupInfo();
    process = new NativeProcess();

    nativeProcessStartupInfo.executable = file;
    nativeProcessStartupInfo.workingDirectory = wkdir;

    process.start(nativeProcessStartupInfo);
}

PushUndo();
